/[gentoo-x86]/eclass/qt4-r2.eclass
Gentoo

Diff of /eclass/qt4-r2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.13 Revision 1.24
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-r2.eclass,v 1.13 2011/11/12 18:26:59 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-r2.eclass,v 1.24 2012/11/08 09:42:51 pesa Exp $
4 4
5# @ECLASS: qt4-r2.eclass 5# @ECLASS: qt4-r2.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4-based packages, second edition. 8# @BLURB: Eclass for Qt4-based packages, second edition.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that may be useful when 10# This eclass contains various functions that may be useful when
11# dealing with packages using Qt4 libraries. Requires EAPI=2 or later. 11# dealing with packages using Qt4 libraries. Requires EAPI=2 or later.
12 12
13case ${EAPI} in 13case ${EAPI} in
14 2|3|4) : ;; 14 2|3|4|5) : ;;
15 *) die "EAPI=${EAPI} is not supported by ${ECLASS} eclass." ;; 15 *) die "qt4-r2.eclass: unsupported EAPI=${EAPI:-0}" ;;
16esac 16esac
17 17
18inherit base eutils multilib toolchain-funcs 18inherit base eutils multilib toolchain-funcs
19 19
20export XDG_CONFIG_HOME="${T}" 20export XDG_CONFIG_HOME="${T}"
21 21
22# @ECLASS-VARIABLE: DOCS
23# @DEFAULT_UNSET
24# @DESCRIPTION:
25# Array containing documents passed to dodoc command.
26# Paths can be absolute or relative to ${S}.
27#
28# Example: DOCS=( ChangeLog README "${WORKDIR}/doc_folder/" )
29
30# @ECLASS-VARIABLE: HTML_DOCS
31# @DEFAULT_UNSET
32# @DESCRIPTION:
33# Array containing documents passed to dohtml command.
34# Paths can be absolute or relative to ${S}.
35#
36# Example: HTML_DOCS=( "doc/document.html" "${WORKDIR}/html_folder/" )
37
22# @ECLASS-VARIABLE: LANGS 38# @ECLASS-VARIABLE: LANGS
39# @DEFAULT_UNSET
23# @DESCRIPTION: 40# @DESCRIPTION:
24# In case your Qt4 application provides various translations, use this variable 41# In case your Qt4 application provides various translations, use this variable
25# to specify them in order to populate "linguas_*" IUSE automatically. Make sure 42# to specify them in order to populate "linguas_*" IUSE automatically. Make sure
26# that you set this variable BEFORE inheriting qt4-r2 eclass. 43# that you set this variable before inheriting qt4-r2 eclass.
44#
27# example: LANGS="en el de" 45# Example: LANGS="de el it ja"
28for x in ${LANGS}; do 46for x in ${LANGS}; do
29 IUSE="${IUSE} linguas_${x}" 47 IUSE+=" linguas_${x}"
30done 48done
31 49
32# @ECLASS-VARIABLE: LANGSLONG 50# @ECLASS-VARIABLE: LANGSLONG
51# @DEFAULT_UNSET
33# @DESCRIPTION: 52# @DESCRIPTION:
34# Same as above, but this variable is for LINGUAS that must be in long format. 53# Same as LANGS, but this variable is for LINGUAS that must be in long format.
35# Remember to set this variable BEFORE inheriting qt4-r2 eclass. 54# Remember to set this variable before inheriting qt4-r2 eclass.
36# Look at ${PORTDIR}/profiles/desc/linguas.desc for details. 55# Look at ${PORTDIR}/profiles/desc/linguas.desc for details.
56#
57# Example: LANGSLONG="en_GB ru_RU"
37for x in ${LANGSLONG}; do 58for x in ${LANGSLONG}; do
38 IUSE="${IUSE} linguas_${x%_*}" 59 IUSE+=" linguas_${x%_*}"
39done 60done
61unset x
62
63# @ECLASS-VARIABLE: PATCHES
64# @DEFAULT_UNSET
65# @DESCRIPTION:
66# Array variable containing all the patches to be applied. This variable
67# is expected to be defined in the global scope of ebuilds. Make sure to
68# specify the full path. This variable is used in src_prepare phase.
69#
70# Example:
71# @CODE
72# PATCHES=(
73# "${FILESDIR}/mypatch.patch"
74# "${FILESDIR}/mypatch2.patch"
75# )
76# @CODE
40 77
41# @FUNCTION: qt4-r2_src_unpack 78# @FUNCTION: qt4-r2_src_unpack
42# @DESCRIPTION: 79# @DESCRIPTION:
43# Default src_unpack function for packages that depend on qt4. If you have to 80# Default src_unpack function for packages that depend on qt4. If you have to
44# override src_unpack in your ebuild (probably you don't need to), call 81# override src_unpack in your ebuild (probably you don't need to), call
47 debug-print-function $FUNCNAME "$@" 84 debug-print-function $FUNCNAME "$@"
48 85
49 base_src_unpack "$@" 86 base_src_unpack "$@"
50} 87}
51 88
52# @ECLASS-VARIABLE: PATCHES
53# @DESCRIPTION:
54# In case you have patches to apply, specify them in PATCHES variable. Make sure
55# to specify the full path. This variable is used in src_prepare phase.
56# example:
57# PATCHES=( "${FILESDIR}"/mypatch.patch
58# "${FILESDIR}"/mypatch2.patch )
59
60# @FUNCTION: qt4-r2_src_prepare 89# @FUNCTION: qt4-r2_src_prepare
61# @DESCRIPTION: 90# @DESCRIPTION:
62# Default src_prepare function for packages that depend on qt4. If you have to 91# Default src_prepare function for packages that depend on qt4. If you have to
63# override src_prepare in your ebuild, you should call qt4-r2_src_prepare in it, 92# override src_prepare in your ebuild, you should call qt4-r2_src_prepare in it,
64# otherwise autopatcher will not work! 93# otherwise autopatcher will not work!
73# Default src_configure function for packages that depend on qt4. If you have to 102# Default src_configure function for packages that depend on qt4. If you have to
74# override src_configure in your ebuild, call qt4-r2_src_configure in it. 103# override src_configure in your ebuild, call qt4-r2_src_configure in it.
75qt4-r2_src_configure() { 104qt4-r2_src_configure() {
76 debug-print-function $FUNCNAME "$@" 105 debug-print-function $FUNCNAME "$@"
77 106
78 local project_file="$(_find_project_file)" 107 local project_file=$(_find_project_file)
79 108
80 if [[ -n ${project_file} ]]; then 109 if [[ -n ${project_file} ]]; then
81 eqmake4 ${project_file} 110 eqmake4 "${project_file}"
82 else 111 else
83 base_src_configure "$@" 112 base_src_configure "$@"
84 fi 113 fi
85} 114}
86 115
93 debug-print-function $FUNCNAME "$@" 122 debug-print-function $FUNCNAME "$@"
94 123
95 base_src_compile "$@" 124 base_src_compile "$@"
96} 125}
97 126
98# @ECLASS-VARIABLE: DOCS
99# @DESCRIPTION:
100# Use this variable if you want to install any documentation.
101# example: DOCS="README AUTHORS"
102
103# @ECLASS-VARIABLE: DOCSDIR
104# @DESCRIPTION:
105# Directory containing documentation. If not specified, ${S} will be used
106# instead.
107
108# @FUNCTION: qt4-r2_src_install 127# @FUNCTION: qt4-r2_src_install
109# @DESCRIPTION: 128# @DESCRIPTION:
110# Default src_install function for qt4-based packages. Installs compiled code, 129# Default src_install function for qt4-based packages. Installs compiled code,
111# documentation (via DOCS variable) and translations (via LANGS and 130# documentation (via DOCS and HTML_DOCS variables).
112# LANGSLONG variables). 131
113qt4-r2_src_install() { 132qt4-r2_src_install() {
114 debug-print-function $FUNCNAME "$@" 133 debug-print-function $FUNCNAME "$@"
115 134
116 emake INSTALL_ROOT="${D}" DESTDIR="${D}" install || die "emake install failed" 135 base_src_install INSTALL_ROOT="${D}" "$@"
117 136
118 # install documentation 137 # backward compatibility for non-array variables
119 if [[ -n ${DOCS} ]]; then 138 if [[ -n ${DOCS} ]] && [[ "$(declare -p DOCS 2>/dev/null 2>&1)" != "declare -a"* ]]; then
120 local dir=${DOCSDIR:-${S}}
121 for doc in ${DOCS}; do
122 dodoc "${dir}/${doc}" || die "dodoc failed" 139 dodoc ${DOCS} || die "dodoc failed"
123 done
124 fi
125}
126
127# Internal function, used by eqmake4 and qt4-r2_src_configure
128# Look for project files:
129# 0 *.pro files found - output null string
130# 1 *.pro file found - output its name
131# 2 or more *.pro files found - if ${PN}.pro or $(basename ${S}).pro
132# are there, output any of them
133# Outputs a project file argument used by eqmake4. Sets nullglob locally
134# to avoid expanding *.pro as "*.pro" when there are no matching files.
135_find_project_file() {
136 shopt -s nullglob
137 local pro_files=(*.pro)
138 shopt -u nullglob
139 local dir_name="$(basename ${S})"
140
141 case ${#pro_files[@]} in
142 1)
143 echo "${pro_files[0]}"
144 ;;
145 *)
146 for pro_file in "${pro_files[@]}"; do
147 if [[ ${pro_file} == "${dir_name}" || ${pro_file} == "${PN}.pro" ]]; then
148 echo "${pro_file}"
149 break
150 fi 140 fi
151 done 141 if [[ -n ${HTML_DOCS} ]] && [[ "$(declare -p HTML_DOCS 2>/dev/null 2>&1)" != "declare -a"* ]]; then
152 ;; 142 dohtml -r ${HTML_DOCS} || die "dohtml failed"
153 esac 143 fi
154} 144}
155 145
156# @FUNCTION: eqmake4 146# @FUNCTION: eqmake4
157# @USAGE: [project file] [parameters to qmake] 147# @USAGE: [project_file] [parameters to qmake]
158# @DESCRIPTION: 148# @DESCRIPTION:
159# Wrapper for Qt4's qmake. If project file isn't specified eqmake4 will 149# Wrapper for Qt4's qmake. If project_file isn't specified, eqmake4 will
160# look for it in current directory (${S}, non-recursively). If more than 150# look for it in the current directory (${S}, non-recursively). If more
161# one project file is found, the ${PN}.pro is processed, provided that it 151# than one project file are found, then ${PN}.pro is processed, provided
162# exists. Otherwise eqmake4 fails. 152# that it exists. Otherwise eqmake4 fails.
153#
163# All the arguments are appended unmodified to qmake command line. For 154# All other arguments are appended unmodified to qmake command line. For
164# recursive build systems, i.e. those based on the subdirs template, you 155# recursive build systems, i.e. those based on the subdirs template, you
165# should run eqmake4 on the top-level project file only, unless you have 156# should run eqmake4 on the top-level project file only, unless you have
166# strong reasons to do things differently. During the building, qmake 157# strong reasons to do things differently. During the building, qmake
167# will be automatically re-invoked with the right arguments on every 158# will be automatically re-invoked with the right arguments on every
168# directory specified inside the top-level project file by the SUBDIRS 159# directory specified inside the top-level project file.
169# variable.
170eqmake4() { 160eqmake4() {
161 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
162
171 ebegin "Running qmake" 163 ebegin "Running qmake"
172 164
173 local qmake_args=("$@") 165 local qmake_args=("$@")
174 166
175 # check if project file was passed as a first argument 167 # check if project file was passed as a first argument
176 # if not, then search for it 168 # if not, then search for it
177 local regexp='.*\.pro' 169 local regexp='.*\.pro'
178 if ! [[ ${1} =~ ${regexp} ]]; then 170 if ! [[ ${1} =~ ${regexp} ]]; then
179 local project_file="$(_find_project_file)" 171 local project_file=$(_find_project_file)
180 if [[ -z ${project_file} ]]; then 172 if [[ -z ${project_file} ]]; then
181 echo 173 echo
182 eerror "No project file found in ${S}!" 174 eerror "No project files found in '${PWD}'!"
183 eerror "This shouldn't happen - please send a bug report to http://bugs.gentoo.org/" 175 eerror "This shouldn't happen - please send a bug report to http://bugs.gentoo.org/"
184 echo 176 echo
185 die "eqmake4 failed" 177 die "eqmake4 failed"
186 fi 178 fi
187 qmake_args+=("${project_file}") 179 qmake_args+=("${project_file}")
188 fi 180 fi
189 181
190 # make sure CONFIG variable is correctly set 182 # make sure CONFIG variable is correctly set
191 # for both release and debug builds 183 # for both release and debug builds
192 local CONFIG_ADD="release" 184 local config_add="release"
193 local CONFIG_REMOVE="debug" 185 local config_remove="debug"
194 if has debug ${IUSE} && use debug; then 186 if has debug ${IUSE} && use debug; then
195 CONFIG_ADD="debug" 187 config_add="debug"
196 CONFIG_REMOVE="release" 188 config_remove="release"
197 fi 189 fi
198 local awkscript='BEGIN { 190 local awkscript='BEGIN {
199 printf "### eqmake4 was here ###\n" > file; 191 printf "### eqmake4 was here ###\n" > file;
192 printf "CONFIG -= debug_and_release %s\n", remove >> file;
193 printf "CONFIG += %s\n\n", add >> file;
200 fixed=0; 194 fixed=0;
201 } 195 }
202 /^[[:blank:]]*CONFIG[[:blank:]]*[\+\*]?=/ { 196 /^[[:blank:]]*CONFIG[[:blank:]]*[\+\*]?=/ {
203 for (i=1; i <= NF; i++) { 197 if (gsub("\\<((" remove ")|(debug_and_release))\\>", "") > 0) {
204 if ($i ~ rem || $i ~ /debug_and_release/) 198 fixed=1;
205 { $i=add; fixed=1; }
206 } 199 }
207 } 200 }
208 /^[[:blank:]]*CONFIG[[:blank:]]*-=/ { 201 /^[[:blank:]]*CONFIG[[:blank:]]*-=/ {
209 for (i=1; i <= NF; i++) { 202 if (gsub("\\<" add "\\>", "") > 0) {
210 if ($i ~ add) { $i=rem; fixed=1; } 203 fixed=1;
211 } 204 }
212 } 205 }
213 { 206 {
214 print >> file; 207 print >> file;
215 } 208 }
216 END { 209 END {
217 printf "\nCONFIG -= debug_and_release %s\n", rem >> file;
218 printf "CONFIG += %s\n", add >> file;
219 print fixed; 210 print fixed;
220 }' 211 }'
221 local file= 212 local file=
222 while read file; do 213 while read file; do
223 grep -q '^### eqmake4 was here ###$' "${file}" && continue 214 grep -q '^### eqmake4 was here ###$' "${file}" && continue
224 local retval=$({ 215 local retval=$({
225 rm -f "${file}" || echo "FAILED" 216 rm -f "${file}" || echo FAIL
226 awk -v file="${file}" -- "${awkscript}" add=${CONFIG_ADD} rem=${CONFIG_REMOVE} || echo "FAILED" 217 awk -v file="${file}" \
218 -v add=${config_add} \
219 -v remove=${config_remove} \
220 -- "${awkscript}" || echo FAIL
227 } < "${file}") 221 } < "${file}")
228 if [[ ${retval} == 1 ]]; then 222 if [[ ${retval} == 1 ]]; then
229 einfo " - fixed CONFIG in ${file}" 223 einfo " - fixed CONFIG in ${file}"
230 elif [[ ${retval} != 0 ]]; then 224 elif [[ ${retval} != 0 ]]; then
231 eerror "An error occurred while processing ${file}" 225 eerror " - error while processing ${file}"
232 die "eqmake4 failed to process '${file}'" 226 die "eqmake4 failed to process ${file}"
233 fi 227 fi
234 done < <(find . -type f -name "*.pr[io]" -printf '%P\n' 2>/dev/null) 228 done < <(find . -type f -name '*.pr[io]' -printf '%P\n' 2>/dev/null)
235
236 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
237 229
238 "${EPREFIX}"/usr/bin/qmake \ 230 "${EPREFIX}"/usr/bin/qmake \
239 -makefile \ 231 -makefile \
240 -config ${CONFIG_ADD} \
241 QTDIR="${EPREFIX}"/usr/$(get_libdir) \ 232 QTDIR="${EPREFIX}"/usr/$(get_libdir) \
242 QMAKE="${EPREFIX}"/usr/bin/qmake \ 233 QMAKE="${EPREFIX}"/usr/bin/qmake \
234 QMAKE_AR="$(tc-getAR) cqs" \
243 QMAKE_CC="$(tc-getCC)" \ 235 QMAKE_CC="$(tc-getCC)" \
244 QMAKE_CXX="$(tc-getCXX)" \ 236 QMAKE_CXX="$(tc-getCXX)" \
245 QMAKE_LINK="$(tc-getCXX)" \ 237 QMAKE_LINK="$(tc-getCXX)" \
246 QMAKE_CFLAGS_RELEASE="${CFLAGS}" \ 238 QMAKE_OBJCOPY="$(tc-getOBJCOPY)" \
239 QMAKE_RANLIB= \
240 QMAKE_STRIP= \
247 QMAKE_CFLAGS_DEBUG="${CFLAGS}" \ 241 QMAKE_CFLAGS="${CFLAGS}" \
248 QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS}" \ 242 QMAKE_CFLAGS_RELEASE= \
243 QMAKE_CFLAGS_DEBUG= \
249 QMAKE_CXXFLAGS_DEBUG="${CXXFLAGS}" \ 244 QMAKE_CXXFLAGS="${CXXFLAGS}" \
250 QMAKE_LFLAGS_RELEASE="${LDFLAGS}" \ 245 QMAKE_CXXFLAGS_RELEASE= \
246 QMAKE_CXXFLAGS_DEBUG= \
251 QMAKE_LFLAGS_DEBUG="${LDFLAGS}" \ 247 QMAKE_LFLAGS="${LDFLAGS}" \
248 QMAKE_LFLAGS_RELEASE= \
249 QMAKE_LFLAGS_DEBUG= \
252 QMAKE_LIBDIR_QT="${EPREFIX}"/usr/$(get_libdir)/qt4 \ 250 QMAKE_LIBDIR_QT="${EPREFIX}"/usr/$(get_libdir)/qt4 \
253 QMAKE_LIBDIR_X11="${EPREFIX}"/usr/$(get_libdir) \ 251 QMAKE_LIBDIR_X11="${EPREFIX}"/usr/$(get_libdir) \
254 QMAKE_LIBDIR_OPENGL="${EPREFIX}"/usr/$(get_libdir) \ 252 QMAKE_LIBDIR_OPENGL="${EPREFIX}"/usr/$(get_libdir) \
255 QMAKE_STRIP= \
256 "${qmake_args[@]}" 253 "${qmake_args[@]}"
257 254
258 # was qmake successful? 255 # was qmake successful?
259 if ! eend $? ; then 256 if ! eend $? ; then
260 echo 257 echo
265 fi 262 fi
266 263
267 return 0 264 return 0
268} 265}
269 266
267# Internal function, used by eqmake4 and qt4-r2_src_configure.
268# Outputs a project file name that can be passed to eqmake4. Sets nullglob
269# locally to avoid expanding *.pro as "*.pro" when there are no matching files.
270# 0 *.pro files found --> outputs null string
271# 1 *.pro file found --> outputs its name
272# 2 or more *.pro files found --> if ${PN}.pro or $(basename ${S}).pro
273# are there, outputs any of them
274_find_project_file() {
275 local dir_name=$(basename "${S}")
276
277 eshopts_push -s nullglob
278 local pro_files=(*.pro)
279 eshopts_pop
280
281 case ${#pro_files[@]} in
282 1)
283 echo "${pro_files[0]}"
284 ;;
285 *)
286 for pro_file in "${pro_files[@]}"; do
287 if [[ ${pro_file} == "${dir_name}.pro" || ${pro_file} == "${PN}.pro" ]]; then
288 echo "${pro_file}"
289 break
290 fi
291 done
292 ;;
293 esac
294}
295
270EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install 296EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install

Legend:
Removed from v.1.13  
changed lines
  Added in v.1.24

  ViewVC Help
Powered by ViewVC 1.1.20